1263412dd51ca6acab9eecce2bf563ca6c9c365f
[csit.git] / resources / libraries / bash / function / ansible.sh
1 #!/usr/bin/env bash
2
3 # Copyright (c) 2020 Cisco and/or its affiliates.
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at:
7 #
8 #     http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 set -exuo pipefail
17
18
19 function ansible_adhoc () {
20
21     # Run ansible ad-hoc command module on hosts in working topology file.
22     #
23     # Variable read:
24     # - ${WORKING_TOPOLOGY} - Reserved working topology.
25     # - ${TOOLS_DIR} - CSIT tools directory, where testbed-setup is located.
26
27     set -exuo pipefail
28
29     if ! installed sshpass; then
30         die "Please install sshpass!"
31     fi
32
33     hosts=($(fgrep host "${WORKING_TOPOLOGY}" | cut -d ":" -f 2)) || {
34         die "Failed to read hosts from working topology!"
35     }
36     pushd "${TOOLS_DIR}"/testbed-setup/ansible || die "Pushd failed!"
37     ANSIBLE_STDOUT_CALLBACK=yaml \
38     ANSIBLE_PIPELINING=true \
39         ansible \
40         --vault-password-file=vault_pass \
41         --extra-vars '@vault.yml' \
42         --inventory inventories/lf_inventory/hosts site.yaml \
43         --limit "$(echo ${hosts[@]//\"})" \
44         --module-name shell \
45         --args \"$(echo $@)\" || die "Failed to run ansible on host!"
46     popd || die "Popd failed!"
47 }
48
49 function ansible_playbook () {
50
51     # Run ansible playbook on hosts in working topology file. Ansible scope is
52     # determined by tags passed as parameters to this function.
53     #
54     # Variable read:
55     # - ${WORKING_TOPOLOGY} - Reserved working topology.
56     # - ${TOOLS_DIR} - CSIT tools directory, where testbed-setup is located.
57
58     set -exuo pipefail
59
60     if ! installed sshpass; then
61         die "Please install sshpass!"
62     fi
63
64     hosts=($(fgrep host "${WORKING_TOPOLOGY}" | cut -d ":" -f 2)) || {
65         die "Failed to read hosts from working topology!"
66     }
67     pushd "${TOOLS_DIR}"/testbed-setup/ansible || die "Pushd failed!"
68     ANSIBLE_STDOUT_CALLBACK=yaml \
69     ANSIBLE_PIPELINING=true \
70         ansible-playbook \
71         --vault-password-file=vault_pass \
72         --extra-vars '@vault.yml' \
73         --inventory inventories/lf_inventory/hosts site.yaml \
74         --limit "$(echo ${hosts[@]//\"})" \
75         --tags "$(echo $@)" || die "Failed to run ansible on host!"
76     popd || die "Popd failed!"
77 }
78
79
80 function installed () {
81
82     # Check if the given utility is installed. Fail if not installed.
83     #
84     # Arguments:
85     # - ${1} - Utility to check.
86     # Returns (implicitly):
87     # - 0 - If command is installed.
88     # - 1 - If command is not installed.
89
90     set -exuo pipefail
91
92     command -v "${1}"
93 }